from flask import Blueprint, request, render_template, send_file
from models import Asset, db
import csv

viewall_bp = Blueprint('viewall', __name__)

@viewall_bp.route('/viewall/', methods=['GET', 'POST'])
def view_list():
    if request.method == 'POST':
        outfile = open('inventory_export.csv', 'w', newline='')
        outcsv = csv.writer(outfile, delimiter='|')
        records = db.session.query(Asset).all()
        outcsv.writerow([column.name for column in Asset.__mapper__.columns])
        [outcsv.writerow([getattr(curr, column.name) for column in Asset.__mapper__.columns]) for curr in records]
        outfile.close()
        return send_file('inventory_export.csv', as_attachment=True)

    items = Asset.query.all()
    return render_template('viewList.html', items=items)